# The E3SM Atmosphere Model (EAM)

EAM is the state-of-the-art atmospheric component of the E3SM model that uses a Spectral Element Dynamical Core and a suite of parameterizations to represent a range of atmospheric processes, which are described in the Technical Guide (see below). Its nominal resolution is roughly 100km in the horizontal, with a model time step of 1800 seconds, and runs with 80 layers in the vertical (model top of 60km).

* The [EAM User Guide](user-guide/index.md) explains how to control EAM when its running within E3SM.
* The [EAM Developer Guide](dev-guide/index.md) explains EAM data structures and how to write new code.
* The [EAM Technical Guide](tech-guide/index.md) explains the science behind EAM's code
