# EAM Technical Guide

This Technical Guide describes the physics of version 3 of the E3SM Atmospheric Model

## Dynamics and Physics

- [HOMME](homme.md): Dynamical core.

- [Atmospheric-Grid](atmosphere-grid-overview.md): Grid used with dynamical core

- [P3](p3.md): Stratiform cloud microphysics scheme.

- [CLUBB](clubb.md): Parameterization of subgrid-scale turbulence and clouds.

- [Zhang-McFarlane](zm.md): Deep convection parameterization.

- [RRTMG](rrtmg.md): Parameterization of radiation.

- [MAM](mam.md): Primary parameterization schemes used to represent aerosols.

- [VBS](vbs.md): Parameterization of secondary organic aerosols.

- [Dust](dust.md): Parameterization of dust emissions.

- [OCEANFILMS](oceanfilms.md): Parameterization of sea soray irganic aerosol emissions.

- [chemUCI + Linoz v3](chemUCIlinozv3.md): Interactive atmospheric chemistry packages.

## Diagnostic outputs

- [COSP](cosp.md): Scheme that allows the model to output satellite simulator output.

- [ARM Diags](armdiags.md): Diagnostic package that allows the model output to be compared against ARM measurements.
