# The Energy Exascale Earth System Model (E3SM)

E3SM is a state-of-the-art fully coupled model of the Earth's climate including important biogeochemical
and cryospheric processes. It is intended to address the most challenging and demanding climate-change
research problems and Department of Energy mission needs while efficiently using DOE Leadership Computing Facilities.

!!! note
    This is the future home for all documentation specific to E3SM and its components. Until complete,
    some documentation will be found at the project's
    [Confluence wiki](https://acme-climate.atlassian.net/wiki/spaces/DOC/overview)

## E3SM Basics

- [Installation](installation.md)
- [User Guide](user-guide/index.md)
- [Development](dev-guide/index.md)

## Component Models

- [EAM](./EAM/index.md)
- [EAMxx](https://docs.e3sm.org/scream/) — not yet supported.
- [ELM](./ELM/index.md)
- [MOSART](./MOSART/index.md)
- [MPAS-Ocean](./MPAS-Ocean/index.md)
- [MPAS-seaice](./MPAS-seaice/index.md)
- [Omega](https://docs.e3sm.org/Omega/omega/) — not yet supported.

## Tools

- [generate_domain_files](./generate_domain_files/index.md)

Please see [Developing Docs](https://acme-climate.atlassian.net/wiki/spaces/DOC/pages/3924787306/Developing+Documentation) to learn about how to contribute to the documentation.
